diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/qos-txop.cc ns-3.42/src/wifi/model/qos-txop.cc
--- ns-3.41/src/wifi/model/qos-txop.cc	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/qos-txop.cc	2024-05-29 15:29:47.204074000 -0700
@@ -35,6 +35,7 @@
 #include "wifi-psdu.h"
 #include "wifi-tx-parameters.h"
 
+#include "ns3/ht-configuration.h"
 #include "ns3/ht-frame-exchange-manager.h"
 #include "ns3/log.h"
 #include "ns3/pointer.h"
@@ -42,11 +43,7 @@
 #include "ns3/simulator.h"
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT                                                                      \
-    if (m_mac)                                                                                     \
-    {                                                                                              \
-        std::clog << "[mac=" << m_mac->GetAddress() << "] ";                                       \
-    }
+#define NS_LOG_APPEND_CONTEXT WIFI_TXOP_NS_LOG_APPEND_CONTEXT
 
 namespace ns3
 {
@@ -103,12 +100,18 @@
     return tid;
 }
 
-QosTxop::QosTxop(AcIndex ac)
-    : Txop(CreateObject<WifiMacQueue>(ac)),
-      m_ac(ac)
+QosTxop::QosTxop()
 {
     NS_LOG_FUNCTION(this);
     m_baManager = CreateObject<BlockAckManager>();
+}
+
+void
+QosTxop::CreateQueue(AcIndex aci)
+{
+    NS_LOG_FUNCTION(this << aci);
+    Txop::CreateQueue(aci);
+    m_ac = aci;
     m_baManager->SetQueue(m_queue);
     m_baManager->SetBlockDestinationCallback(
         Callback<void, Mac48Address, uint8_t>([this](Mac48Address recipient, uint8_t tid) {
@@ -334,10 +337,14 @@
 {
     // remove MSDUs with expired lifetime starting from the head of the queue
     m_queue->WipeAllExpiredMpdus();
-    bool queueIsNotEmpty = (bool)(m_queue->PeekFirstAvailable(linkId));
+    auto hasFramesToTransmit = static_cast<bool>(m_queue->PeekFirstAvailable(linkId));
 
-    NS_LOG_FUNCTION(this << queueIsNotEmpty);
-    return queueIsNotEmpty;
+    // Print the number of packets that are actually in the queue (which might not be
+    // eligible for transmission for some reason, e.g., TID not mapped to the link, etc.)
+    NS_LOG_DEBUG(m_ac << " on link " << +linkId << (hasFramesToTransmit ? " has" : " has not")
+                      << " frames to transmit with " << m_queue->GetNPackets()
+                      << " packets in the queue");
+    return hasFramesToTransmit;
 }
 
 uint16_t
@@ -387,7 +394,7 @@
         }
         WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, recipient, tid);
         if (auto mask = m_mac->GetMacQueueScheduler()->GetQueueLinkMask(m_ac, queueId, linkId);
-            !mask || mask->none())
+            mask && mask->none())
         {
             return m_queue->PeekByQueueId(queueId, mpdu);
         }
@@ -425,7 +432,7 @@
             // if the MPDU is not already in-flight on the link for which we are requesting an
             // MPDU and the number of links on which the MPDU is in-flight is less than the
             // maximum number, then we can transmit this MPDU
-            if (linkIds.count(linkId) == 0 && linkIds.size() < m_nMaxInflights)
+            if (!linkIds.contains(linkId) && (linkIds.size() < m_nMaxInflights))
             {
                 break;
             }
@@ -535,7 +542,7 @@
 
         // try A-MSDU aggregation if the MPDU does not contain an A-MSDU and does not already
         // have a sequence number assigned (may be a retransmission)
-        if (m_mac->GetHtSupported() && !recipient.IsBroadcast() &&
+        if (m_mac->GetHtConfiguration() && !recipient.IsBroadcast() &&
             !peekedItem->GetHeader().IsQosAmsdu() && !peekedItem->HasSeqNoAssigned() &&
             !peekedItem->IsFragment())
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/qos-txop.h ns-3.42/src/wifi/model/qos-txop.h
--- ns-3.41/src/wifi/model/qos-txop.h	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/qos-txop.h	2024-05-29 15:29:47.204074000 -0700
@@ -79,13 +79,7 @@
      */
     static TypeId GetTypeId();
 
-    /**
-     * Constructor
-     *
-     * \param ac the Access Category
-     */
-    QosTxop(AcIndex ac = AC_UNDEF);
-
+    QosTxop();
     ~QosTxop() override;
 
     bool IsQosTxop() const override;
@@ -439,6 +433,7 @@
     };
 
     void DoDispose() override;
+    void CreateQueue(AcIndex aci) override;
 
     /**
      * Get a reference to the link associated with the given ID.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/rate-control/aparf-wifi-manager.cc ns-3.42/src/wifi/model/rate-control/aparf-wifi-manager.cc
--- ns-3.41/src/wifi/model/rate-control/aparf-wifi-manager.cc	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/rate-control/aparf-wifi-manager.cc	2024-05-29 15:29:47.204074000 -0700
@@ -278,13 +278,10 @@
     NS_LOG_DEBUG("station=" << station << " data ok success=" << station->m_nSuccess << ", rate="
                             << +station->m_rateIndex << ", power=" << +station->m_powerLevel);
 
-    if ((station->m_aparfState == AparfWifiManager::High) &&
-        (station->m_nSuccess >= station->m_successThreshold))
-    {
-        station->m_aparfState = AparfWifiManager::Spread;
-    }
-    else if ((station->m_aparfState == AparfWifiManager::Low) &&
-             (station->m_nSuccess >= station->m_successThreshold))
+    if ((station->m_aparfState == AparfWifiManager::High ||
+         station->m_aparfState == AparfWifiManager::Low) &&
+        station->m_nSuccess >= station->m_successThreshold)
+
     {
         station->m_aparfState = AparfWifiManager::Spread;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/rate-control/ideal-wifi-manager.cc ns-3.42/src/wifi/model/rate-control/ideal-wifi-manager.cc
--- ns-3.41/src/wifi/model/rate-control/ideal-wifi-manager.cc	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/rate-control/ideal-wifi-manager.cc	2024-05-29 15:29:47.208073900 -0700
@@ -19,7 +19,9 @@
 
 #include "ideal-wifi-manager.h"
 
+#include "ns3/ht-configuration.h"
 #include "ns3/log.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
 
 #include <algorithm>
@@ -130,7 +132,7 @@
         AddSnrThreshold(txVector, GetPhy()->CalculateSnr(txVector, m_ber));
     }
     // Add all MCSes
-    if (GetHtSupported())
+    if (GetPhy()->GetDevice()->GetHtConfiguration())
     {
         for (const auto& mode : GetPhy()->GetMcsList())
         {
@@ -360,7 +362,8 @@
     }
     else
     {
-        if (GetHtSupported() && GetHtSupported(st))
+        if (GetPhy()->GetDevice()->GetHtConfiguration() &&
+            (GetHtSupported(st) || GetStationHe6GhzCapabilities(st->m_state->m_address)))
         {
             for (uint8_t i = 0; i < GetNMcsSupported(station); i++)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.42/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.41/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2024-05-29 15:29:47.208073900 -0700
@@ -35,11 +35,13 @@
 
 #include "minstrel-ht-wifi-manager.h"
 
+#include "ns3/ht-configuration.h"
 #include "ns3/log.h"
 #include "ns3/packet.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
 #include "ns3/wifi-mac.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
 
 #include <iomanip>
@@ -196,32 +198,35 @@
     {
         m_numGroups = MAX_HT_SUPPORTED_STREAMS * MAX_HT_STREAM_GROUPS;
         m_numRates = MAX_HT_GROUP_RATES;
-        if (GetVhtSupported())
-        {
-            m_numGroups += MAX_VHT_SUPPORTED_STREAMS * MAX_VHT_STREAM_GROUPS;
-            m_numRates = MAX_VHT_GROUP_RATES;
-        }
-        if (GetHeSupported())
-        {
-            m_numGroups += MAX_HE_SUPPORTED_STREAMS * MAX_HE_STREAM_GROUPS;
-            m_numRates = MAX_HE_GROUP_RATES;
-        }
+    }
+    if (GetVhtSupported())
+    {
+        m_numGroups += MAX_VHT_SUPPORTED_STREAMS * MAX_VHT_STREAM_GROUPS;
+        m_numRates = MAX_VHT_GROUP_RATES;
+    }
+    if (GetHeSupported())
+    {
+        m_numGroups += MAX_HE_SUPPORTED_STREAMS * MAX_HE_STREAM_GROUPS;
+        m_numRates = MAX_HE_GROUP_RATES;
+    }
 
-        /**
-         *  Initialize the groups array.
-         *  The HT groups come first, then the VHT ones, and finally the HE ones.
-         *  Minstrel maintains different types of indexes:
-         *  - A global continuous index, which identifies all rates within all groups, in [0,
-         * m_numGroups * m_numRates]
-         *  - A groupId, which indexes a group in the array, in [0, m_numGroups]
-         *  - A rateId, which identifies a rate within a group, in [0, m_numRates]
-         *  - A deviceIndex, which indexes a MCS in the PHY MCS array.
-         *  - A mcsIndex, which indexes a MCS in the wifi-remote-station-manager supported MCSs
-         * array.
-         */
-        NS_LOG_DEBUG("Initialize MCS Groups:");
-        m_minstrelGroups = MinstrelMcsGroups(m_numGroups);
+    /**
+     *  Initialize the groups array.
+     *  The HT groups come first, then the VHT ones, and finally the HE ones.
+     *  Minstrel maintains different types of indexes:
+     *  - A global continuous index, which identifies all rates within all groups, in [0,
+     * m_numGroups * m_numRates]
+     *  - A groupId, which indexes a group in the array, in [0, m_numGroups]
+     *  - A rateId, which identifies a rate within a group, in [0, m_numRates]
+     *  - A deviceIndex, which indexes a MCS in the PHY MCS array.
+     *  - A mcsIndex, which indexes a MCS in the wifi-remote-station-manager supported MCSs
+     * array.
+     */
+    NS_LOG_DEBUG("Initialize MCS Groups:");
+    m_minstrelGroups = MinstrelMcsGroups(m_numGroups);
 
+    if (GetHtSupported())
+    {
         // Initialize all HT groups
         for (uint16_t chWidth = 20; chWidth <= MAX_HT_WIDTH; chWidth *= 2)
         {
@@ -277,133 +282,129 @@
                 gi /= 2;
             }
         }
+    }
 
-        if (GetVhtSupported())
+    if (GetVhtSupported())
+    {
+        // Initialize all VHT groups
+        for (uint16_t chWidth = 20; chWidth <= MAX_VHT_WIDTH; chWidth *= 2)
         {
-            // Initialize all VHT groups
-            for (uint16_t chWidth = 20; chWidth <= MAX_VHT_WIDTH; chWidth *= 2)
+            for (int gi = 800; gi >= 400;)
             {
-                for (int gi = 800; gi >= 400;)
+                for (uint8_t streams = 1; streams <= MAX_VHT_SUPPORTED_STREAMS; streams++)
                 {
-                    for (uint8_t streams = 1; streams <= MAX_VHT_SUPPORTED_STREAMS; streams++)
+                    uint8_t groupId = GetVhtGroupId(streams, gi, chWidth);
+
+                    m_minstrelGroups[groupId].streams = streams;
+                    m_minstrelGroups[groupId].gi = gi;
+                    m_minstrelGroups[groupId].chWidth = chWidth;
+                    m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_VHT;
+                    m_minstrelGroups[groupId].isSupported = false;
+
+                    // Check capabilities of the device
+                    if (!(!GetShortGuardIntervalSupported() &&
+                          (gi == 400)) /// Is SGI supported by the transmitter?
+                        && (GetPhy()->GetChannelWidth() >=
+                            chWidth) /// Is channel width supported by the transmitter?
+                        && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
+                            streams)) /// Are streams supported by the transmitter?
                     {
-                        uint8_t groupId = GetVhtGroupId(streams, gi, chWidth);
+                        m_minstrelGroups[groupId].isSupported = true;
 
-                        m_minstrelGroups[groupId].streams = streams;
-                        m_minstrelGroups[groupId].gi = gi;
-                        m_minstrelGroups[groupId].chWidth = chWidth;
-                        m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_VHT;
-                        m_minstrelGroups[groupId].isSupported = false;
-
-                        // Check capabilities of the device
-                        if (!(!GetShortGuardIntervalSupported() &&
-                              (gi == 400)) /// Is SGI supported by the transmitter?
-                            && (GetPhy()->GetChannelWidth() >=
-                                chWidth) /// Is channel width supported by the transmitter?
-                            && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
-                                streams)) /// Are streams supported by the transmitter?
+                        // Calculate TX time for all rates of the group
+                        WifiModeList vhtMcsList = GetVhtDeviceMcsList();
+                        for (uint8_t i = 0; i < MAX_VHT_GROUP_RATES; i++)
                         {
-                            m_minstrelGroups[groupId].isSupported = true;
-
-                            // Calculate TX time for all rates of the group
-                            WifiModeList vhtMcsList = GetVhtDeviceMcsList();
-                            for (uint8_t i = 0; i < MAX_VHT_GROUP_RATES; i++)
+                            WifiMode mode = vhtMcsList[i];
+                            // Check for invalid VHT MCSs and do not add time to array.
+                            if (IsValidMcs(GetPhy(), streams, chWidth, mode))
                             {
-                                WifiMode mode = vhtMcsList[i];
-                                // Check for invalid VHT MCSs and do not add time to array.
-                                if (IsValidMcs(GetPhy(), streams, chWidth, mode))
-                                {
-                                    AddFirstMpduTxTime(
-                                        groupId,
-                                        mode,
-                                        CalculateMpduTxDuration(GetPhy(),
-                                                                streams,
-                                                                gi,
-                                                                chWidth,
-                                                                mode,
-                                                                FIRST_MPDU_IN_AGGREGATE));
-                                    AddMpduTxTime(
-                                        groupId,
-                                        mode,
-                                        CalculateMpduTxDuration(GetPhy(),
-                                                                streams,
-                                                                gi,
-                                                                chWidth,
-                                                                mode,
-                                                                MIDDLE_MPDU_IN_AGGREGATE));
-                                }
+                                AddFirstMpduTxTime(
+                                    groupId,
+                                    mode,
+                                    CalculateMpduTxDuration(GetPhy(),
+                                                            streams,
+                                                            gi,
+                                                            chWidth,
+                                                            mode,
+                                                            FIRST_MPDU_IN_AGGREGATE));
+                                AddMpduTxTime(groupId,
+                                              mode,
+                                              CalculateMpduTxDuration(GetPhy(),
+                                                                      streams,
+                                                                      gi,
+                                                                      chWidth,
+                                                                      mode,
+                                                                      MIDDLE_MPDU_IN_AGGREGATE));
                             }
-                            NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams
-                                                              << "," << gi << "," << chWidth
-                                                              << ")");
                         }
+                        NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams << ","
+                                                          << gi << "," << chWidth << ")");
                     }
-                    gi /= 2;
                 }
+                gi /= 2;
             }
         }
+    }
 
-        if (GetHeSupported())
+    if (GetHeSupported())
+    {
+        // Initialize all HE groups
+        for (uint16_t chWidth = 20; chWidth <= MAX_HE_WIDTH; chWidth *= 2)
         {
-            // Initialize all HE groups
-            for (uint16_t chWidth = 20; chWidth <= MAX_HE_WIDTH; chWidth *= 2)
+            for (int gi = 3200; gi >= 800;)
             {
-                for (int gi = 3200; gi >= 800;)
+                for (uint8_t streams = 1; streams <= MAX_HE_SUPPORTED_STREAMS; streams++)
                 {
-                    for (uint8_t streams = 1; streams <= MAX_HE_SUPPORTED_STREAMS; streams++)
+                    uint8_t groupId = GetHeGroupId(streams, gi, chWidth);
+
+                    m_minstrelGroups[groupId].streams = streams;
+                    m_minstrelGroups[groupId].gi = gi;
+                    m_minstrelGroups[groupId].chWidth = chWidth;
+                    m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_HE;
+                    m_minstrelGroups[groupId].isSupported = false;
+
+                    // Check capabilities of the device
+                    if ((GetGuardInterval() <= gi) /// Is GI supported by the transmitter?
+                        && (GetPhy()->GetChannelWidth() >=
+                            chWidth) /// Is channel width supported by the transmitter?
+                        && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
+                            streams)) /// Are streams supported by the transmitter?
                     {
-                        uint8_t groupId = GetHeGroupId(streams, gi, chWidth);
+                        m_minstrelGroups[groupId].isSupported = true;
 
-                        m_minstrelGroups[groupId].streams = streams;
-                        m_minstrelGroups[groupId].gi = gi;
-                        m_minstrelGroups[groupId].chWidth = chWidth;
-                        m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_HE;
-                        m_minstrelGroups[groupId].isSupported = false;
-
-                        // Check capabilities of the device
-                        if ((GetGuardInterval() <= gi) /// Is GI supported by the transmitter?
-                            && (GetPhy()->GetChannelWidth() >=
-                                chWidth) /// Is channel width supported by the transmitter?
-                            && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
-                                streams)) /// Are streams supported by the transmitter?
+                        // Calculate tx time for all rates of the group
+                        WifiModeList heMcsList = GetHeDeviceMcsList();
+                        for (uint8_t i = 0; i < MAX_HE_GROUP_RATES; i++)
                         {
-                            m_minstrelGroups[groupId].isSupported = true;
-
-                            // Calculate tx time for all rates of the group
-                            WifiModeList heMcsList = GetHeDeviceMcsList();
-                            for (uint8_t i = 0; i < MAX_HE_GROUP_RATES; i++)
+                            WifiMode mode = heMcsList.at(i);
+                            // Check for invalid HE MCSs and do not add time to array.
+                            if (IsValidMcs(GetPhy(), streams, chWidth, mode))
                             {
-                                WifiMode mode = heMcsList.at(i);
-                                // Check for invalid HE MCSs and do not add time to array.
-                                if (IsValidMcs(GetPhy(), streams, chWidth, mode))
-                                {
-                                    AddFirstMpduTxTime(
-                                        groupId,
-                                        mode,
-                                        CalculateMpduTxDuration(GetPhy(),
-                                                                streams,
-                                                                gi,
-                                                                chWidth,
-                                                                mode,
-                                                                FIRST_MPDU_IN_AGGREGATE));
-                                    AddMpduTxTime(
-                                        groupId,
-                                        mode,
-                                        CalculateMpduTxDuration(GetPhy(),
-                                                                streams,
-                                                                gi,
-                                                                chWidth,
-                                                                mode,
-                                                                MIDDLE_MPDU_IN_AGGREGATE));
-                                }
+                                AddFirstMpduTxTime(
+                                    groupId,
+                                    mode,
+                                    CalculateMpduTxDuration(GetPhy(),
+                                                            streams,
+                                                            gi,
+                                                            chWidth,
+                                                            mode,
+                                                            FIRST_MPDU_IN_AGGREGATE));
+                                AddMpduTxTime(groupId,
+                                              mode,
+                                              CalculateMpduTxDuration(GetPhy(),
+                                                                      streams,
+                                                                      gi,
+                                                                      chWidth,
+                                                                      mode,
+                                                                      MIDDLE_MPDU_IN_AGGREGATE));
                             }
-                            NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams
-                                                              << "," << gi << "," << chWidth
-                                                              << ")");
                         }
+                        NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams << ","
+                                                          << gi << "," << chWidth << ")");
                     }
-                    gi /= 2;
                 }
+                gi /= 2;
             }
         }
     }
@@ -513,7 +514,7 @@
 
     // Use the variable in the station to indicate whether the device supports HT.
     // When correct information available it will be checked.
-    station->m_isHt = GetHtSupported();
+    station->m_isHt = static_cast<bool>(GetPhy()->GetDevice()->GetHtConfiguration());
 
     return station;
 }
@@ -533,7 +534,7 @@
          *  the station will not support HT either.
          *  We save from using another check and variable.
          */
-        if (!GetHtSupported(station))
+        if (!GetHtSupported(station) && !GetStationHe6GhzCapabilities(station->m_state->m_address))
         {
             NS_LOG_INFO("non-HT station " << station);
             station->m_isHt = false;
@@ -975,7 +976,7 @@
         return txRate;
     }
 
-    NS_ASSERT(GetHtSupported());
+    NS_ASSERT(GetPhy()->GetDevice()->GetHtConfiguration() != nullptr);
     NS_ASSERT(group.chWidth % 20 == 0);
     // try halving the channel width and check if the group with the same number of
     // streams and same GI is supported, until either a supported group is found or
@@ -1041,55 +1042,52 @@
         }
         return vector;
     }
-    else
-    {
-        station->m_txrate = UpdateRateAfterAllowedWidth(station->m_txrate, allowedWidth);
-        NS_LOG_DEBUG("DoGetDataMode m_txrate= " << station->m_txrate);
 
-        uint8_t rateId = GetRateId(station->m_txrate);
-        uint8_t groupId = GetGroupId(station->m_txrate);
-        uint8_t mcsIndex = station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex;
+    station->m_txrate = UpdateRateAfterAllowedWidth(station->m_txrate, allowedWidth);
+    NS_LOG_DEBUG("DoGetDataMode m_txrate= " << station->m_txrate);
 
-        NS_LOG_DEBUG("DoGetDataMode rateId= " << +rateId << " groupId= " << +groupId
-                                              << " mode= " << GetMcsSupported(station, mcsIndex));
+    uint8_t rateId = GetRateId(station->m_txrate);
+    uint8_t groupId = GetGroupId(station->m_txrate);
+    uint8_t mcsIndex = station->m_groupsTable[groupId].m_ratesTable[rateId].mcsIndex;
 
-        McsGroup group = m_minstrelGroups[groupId];
+    NS_LOG_DEBUG("DoGetDataMode rateId= " << +rateId << " groupId= " << +groupId
+                                          << " mode= " << GetMcsSupported(station, mcsIndex));
 
-        // Check consistency of rate selected.
-        if (((group.type == WIFI_MINSTREL_GROUP_HE) && (group.gi < GetGuardInterval(station))) ||
-            (((group.type == WIFI_MINSTREL_GROUP_HT) || (group.type == WIFI_MINSTREL_GROUP_VHT)) &&
-             (group.gi == 400) && !GetShortGuardIntervalSupported(station)) ||
-            (group.chWidth > GetChannelWidth(station)) ||
-            (group.streams > GetNumberOfSupportedStreams(station)))
-        {
-            NS_FATAL_ERROR("Inconsistent group selected. Group: ("
-                           << +group.streams << "," << group.gi << "," << group.chWidth << ")"
-                           << " Station capabilities: (" << GetNumberOfSupportedStreams(station)
-                           << ","
-                           << ((group.type == WIFI_MINSTREL_GROUP_HE)
-                                   ? GetGuardInterval(station)
-                                   : (GetShortGuardIntervalSupported(station) ? 400 : 800))
-                           << "," << GetChannelWidth(station) << ")");
-        }
-        WifiMode mode = GetMcsSupported(station, mcsIndex);
-        WifiTxVector txVector{
-            mode,
-            GetDefaultTxPowerLevel(),
-            GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()),
-            group.gi,
-            GetNumberOfAntennas(),
-            group.streams,
-            GetNess(station),
-            GetPhy()->GetTxBandwidth(mode, group.chWidth),
-            GetAggregation(station) && !station->m_isSampling};
-        uint64_t dataRate = mode.GetDataRate(txVector);
-        if (m_currentRate != dataRate && !station->m_isSampling)
-        {
-            NS_LOG_DEBUG("New datarate: " << dataRate);
-            m_currentRate = dataRate;
-        }
-        return txVector;
+    McsGroup group = m_minstrelGroups[groupId];
+
+    // Check consistency of rate selected.
+    if (((group.type == WIFI_MINSTREL_GROUP_HE) && (group.gi < GetGuardInterval(station))) ||
+        (((group.type == WIFI_MINSTREL_GROUP_HT) || (group.type == WIFI_MINSTREL_GROUP_VHT)) &&
+         (group.gi == 400) && !GetShortGuardIntervalSupported(station)) ||
+        (group.chWidth > GetChannelWidth(station)) ||
+        (group.streams > GetNumberOfSupportedStreams(station)))
+    {
+        NS_FATAL_ERROR("Inconsistent group selected. Group: ("
+                       << +group.streams << "," << group.gi << "," << group.chWidth << ")"
+                       << " Station capabilities: (" << GetNumberOfSupportedStreams(station) << ","
+                       << ((group.type == WIFI_MINSTREL_GROUP_HE)
+                               ? GetGuardInterval(station)
+                               : (GetShortGuardIntervalSupported(station) ? 400 : 800))
+                       << "," << GetChannelWidth(station) << ")");
+    }
+    WifiMode mode = GetMcsSupported(station, mcsIndex);
+    WifiTxVector txVector{
+        mode,
+        GetDefaultTxPowerLevel(),
+        GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()),
+        group.gi,
+        GetNumberOfAntennas(),
+        group.streams,
+        GetNess(station),
+        GetPhy()->GetTxBandwidth(mode, group.chWidth),
+        GetAggregation(station) && !station->m_isSampling};
+    uint64_t dataRate = mode.GetDataRate(txVector);
+    if (m_currentRate != dataRate && !station->m_isSampling)
+    {
+        NS_LOG_DEBUG("New datarate: " << dataRate);
+        m_currentRate = dataRate;
     }
+    return txVector;
 }
 
 WifiTxVector
@@ -2181,8 +2179,12 @@
     {
         widthIndex = 0;
     }
-    uint8_t groupId = (MAX_HT_STREAM_GROUPS * MAX_HT_SUPPORTED_STREAMS); /// add all HT groups
-    if (GetVhtSupported()) /// This check is needed since we do not support VHT in 2.4 GHz band
+    uint8_t groupId = 0;
+    if (GetHtSupported()) // This check is needed since HT is not supported in 6 GHz band
+    {
+        groupId = MAX_HT_STREAM_GROUPS * MAX_HT_SUPPORTED_STREAMS;
+    }
+    if (GetVhtSupported()) // This check is needed since VHT is not supported in 2.4 and 6 GHz bands
     {
         groupId += MAX_VHT_STREAM_GROUPS * MAX_VHT_SUPPORTED_STREAMS; /// add all VHT groups
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.42/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.41/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2024-05-29 15:29:47.208073900 -0700
@@ -730,14 +730,10 @@
     uint8_t index_max_prob = 0;
     for (uint8_t i = 0; i < station->m_nModes; i++)
     {
-        if ((station->m_minstrelTable[i].ewmaProb >= 95 * 180) &&
-            (station->m_minstrelTable[i].throughput >=
-             station->m_minstrelTable[index_max_prob].throughput))
-        {
-            index_max_prob = i;
-            max_prob = station->m_minstrelTable[i].ewmaProb;
-        }
-        else if (station->m_minstrelTable[i].ewmaProb >= max_prob)
+        if ((station->m_minstrelTable[i].ewmaProb >= 95 * 180 &&
+             station->m_minstrelTable[i].throughput >=
+                 station->m_minstrelTable[index_max_prob].throughput) ||
+            (station->m_minstrelTable[i].ewmaProb >= max_prob))
         {
             index_max_prob = i;
             max_prob = station->m_minstrelTable[i].ewmaProb;
